//+------------------------------------------------------------------+
//|                                              TestCanvas2Rect.mq5 |
//|                                  Copyright 2023, MetaQuotes Ltd. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2023, MetaQuotes Ltd."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property indicator_chart_window
#include <Canvas\iCanvas_CB.mqh> //https://www.mql5.com/ru/code/22164

int OnInit() {

   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[]) {
   return(rates_total);
}

//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam) {
   if (id==CHARTEVENT_CHART_CHANGE) Draw();

}
//+------------------------------------------------------------------+
void Draw() {
   Canvas.Erase(0x00FFFFFF);
   Canvas.FillRectangle((int)Canvas.X(114.0),(int)Canvas.Y(iHigh(_Symbol,0,114)),(int)Canvas.X(97.0),(int)Canvas.Y(iLow(_Symbol,0,97)),0x500000FF);
   Canvas.FillRectangle((int)Canvas.X(50.0),(int)Canvas.Y(iHigh(_Symbol,0,50)),(int)Canvas.X(5.0),(int)Canvas.Y(iLow(_Symbol,0,5)),0x50FF0000);
   Canvas.Update();
}
